MethodHandles.Lookup.ClassOption (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.invoke, class: MethodHandles, class: Lookup, enum: ClassOption
Keywords: java.lang.invoke.MethodHandles.Lookup.ClassOption class

# Enum Class MethodHandles.Lookup.ClassOption

java.lang.Object
java.lang.Enum<MethodHandles.Lookup.ClassOption>
java.lang.invoke.MethodHandles.Lookup.ClassOption

All Implemented Interfaces:
  `Serializable, Comparable<MethodHandles.Lookup.ClassOption>, Constable`

Enclosing class:
  `MethodHandles.Lookup`

public static enum MethodHandles.Lookup.ClassOption extends Enum<MethodHandles.Lookup.ClassOption>
The set of class options that specify whether a hidden class created by `Lookup::defineHiddenClass` method is dynamically added as a new member to the nest of a lookup class and/or whether a hidden class has a strong relationship with the class loader marked as its defining loader.

Since:
  15

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NESTMATE`
  Specifies that a hidden class be added to nest of a lookup class as a nestmate.
  `STRONG`
  Specifies that a hidden class has a strong relationship with the class loader marked as its defining loader, as a normal class or interface has with its own defining loader.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static MethodHandles.Lookup.ClassOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static MethodHandles.Lookup.ClassOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(MethodHandles.Lookup.ClassOption o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<MethodHandles.Lookup.ClassOption>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<MethodHandles.Lookup.ClassOption>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### NESTMATE

    public static final MethodHandles.Lookup.ClassOption NESTMATE
    Specifies that a hidden class be added to nest of a lookup class as a nestmate.

    A hidden nestmate class has access to the private members of all classes and interfaces in the same nest.

    See Also:
      - `Class.getNestHost()`

  - ### STRONG

    public static final MethodHandles.Lookup.ClassOption STRONG
    Specifies that a hidden class has a strong relationship with the class loader marked as its defining loader, as a normal class or interface has with its own defining loader. This means that the hidden class may be unloaded if and only if its defining loader is not reachable and thus may be reclaimed by a garbage collector (JLS 12.7).

    By default, a hidden class or interface may be unloaded even if the class loader that is marked as its defining loader is reachable.

    See Java Language Specification:
      12.7 Unloading of Classes and Interfaces

- ## Method Details

  - ### values

    public static MethodHandles.Lookup.ClassOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static MethodHandles.Lookup.ClassOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null